/***************************************************************************
**
**  This file is part of geopsy.
**
**  geopsy is free software: you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation, either version 3 of the License, or
**  (at your option) any later version.
**
**  geopsy is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with Foobar.  If not, see <http://www.gnu.org/licenses/>
**
**  See http://www.geopsy.org for more information.
**
**  Created: 2005-09-20
**  Copyright: 2005-2019
**    Marc Wathelet
**    Marc Wathelet (LGIT, Grenoble, France)
**
***************************************************************************/

#include "Engine.h"
#include "SubtractSignals.h"
#include "SubtractGroupItem.h"

SubtractSignals::SubtractSignals(QWidget *parent, Qt::WindowFlags f)
    : Dialog(parent, f)
{
  TRACE;
  setupUi(this);
}

AbstractSignalGroup * SubtractSignals::group()
{
  TRACE;
  QModelIndex i=groupTree->selectionModel()->currentIndex();
  if( !i.isValid()) return 0;
  return SubtractGroupItem::group(i);
}

void SubtractSignals::setSubPool(SubSignalPool * subPool)
{
  TRACE;
  // Signal list
  signalList->clear();
  int n=subPool->count();
  for(int i=0;i<n;i++ )
    signalList->addItem(tr("%1. %2").arg(i+1).arg(subPool->at(i)->name()));
  // Groups
  SignalDatabase * db=Engine::instance()->database(this);
  ASSERT(db);
  SubtractGroupItem * gi=new SubtractGroupItem(n, this);
  gi->setDatabase(db);
  groupTree->setModel(gi);
  groupTree->header()->hide();
  groupTree->setSelectionBehavior(QAbstractItemView::SelectRows);
  groupTree->setSelectionMode(QAbstractItemView::SingleSelection);
  groupTree->setEditTriggers(QAbstractItemView::NoEditTriggers);
}
